using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace WindowsApplication3
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(48, 24);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(368, 232);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 3;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 286);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridDataBoundGrid1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		PropertyDescriptorCollection pdc;
		ArrayList dataSourceList;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//setup datasource
			dataSourceList = new ArrayList();

			dataSourceList.Add(new Person("1", "name1", new Location("address1", "zip1")));
			dataSourceList.Add(new Person("2", "name2", new Location("address2", "zip2")));
			dataSourceList.Add(new Person("3", "name3", new Location("address3", "zip3")));
			dataSourceList.Add(new Person("4", "name4", new Location("address4", "zip4")));

			//get a reference to LocationPropertyDescriptor collection - need an instance
			Location loc = ((Person)dataSourceList[0]).Loc;
			this.pdc = ((ITypedList)loc).GetItemProperties(null);


			//set up GridBoundColumns using '.' in the nested property
			GridBoundColumn gbc = new GridBoundColumn();
			gbc.MappingName = "Name";
            this.gridDataBoundGrid1.GridBoundColumns.Add(gbc);

			gbc = new GridBoundColumn();
			gbc.MappingName = "Loc.Zip";
			gbc.HeaderText = "Zip";
			this.gridDataBoundGrid1.GridBoundColumns.Add(gbc);

			gbc = new GridBoundColumn();
			gbc.MappingName = "Loc.Address";
			gbc.HeaderText = "Address";
			this.gridDataBoundGrid1.GridBoundColumns.Add(gbc);

			this.gridDataBoundGrid1.DataSource = dataSourceList;	

			//handle these event to get at the nested property values
			this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(gridModel_QueryCellInfo);
			this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(gridModel_SaveCellInfo);
		}

		private void gridModel_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				int field = this.gridDataBoundGrid1.Binder.ColIndexToField(e.ColIndex);
				int i = this.gridDataBoundGrid1.GridBoundColumns[field].MappingName.IndexOf(".");
				if(i > 0)
				{
					int pos = this.gridDataBoundGrid1.Binder.RowIndexToPosition(e.RowIndex);
					Location loc = (dataSourceList[pos] as Person).Loc;
					string name = this.gridDataBoundGrid1.GridBoundColumns[field].MappingName.Substring(i + 1);
					e.Style.CellValue = this.pdc[name].GetValue(loc);
				}
			}
		}

		private void gridModel_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				int field = this.gridDataBoundGrid1.Binder.ColIndexToField(e.ColIndex);
				int i = this.gridDataBoundGrid1.GridBoundColumns[field].MappingName.IndexOf(".");
				if(i > 0)
				{
					int pos = this.gridDataBoundGrid1.Binder.RowIndexToPosition(e.RowIndex);
					Location loc = (dataSourceList[pos] as Person).Loc;
					string name = this.gridDataBoundGrid1.GridBoundColumns[field].MappingName.Substring(i + 1);
					this.pdc[name].SetValue(loc, e.Style.CellValue);
					e.Handled = true;
				}
				 
			}
		}
	}

	#region Person class

	public class Person
	{
		string i;
		string n;
		Location l;
		public Person(string i, string n, Location l)
		{
			this.i = i;
			this.n = n;
			this.l = l;
		}

		public string ID
		{
			get{return i;}
			set{i = value;}
		}
		public string Name
		{
			get{return n;}
			set{n = value;}
		}
		public Location Loc
		{
			get{return l;}
			set{l = value;}
		}
	}

	#endregion

	#region Location class - implements ITypedList using LocationPropertyDescriptor

	public class Location : ITypedList
	{
		string a;
		string z;
		PropertyDescriptorCollection pdc;
		
		public Location(string a, string z)
		{
			this.a = a;
			this.z = z;

			LocationPropertyDescriptor[] pds = new LocationPropertyDescriptor[2];

			PropertyDescriptor pd = TypeDescriptor.CreateProperty(typeof(Location), "Address", typeof(string), null );
			pds[0] = new LocationPropertyDescriptor(pd, "Address");

			pd = TypeDescriptor.CreateProperty(typeof(Location), "Zip", typeof(string), null );
			pds[1] = new LocationPropertyDescriptor(pd, "Zip");

			pdc = new PropertyDescriptorCollection(pds);
		}

		public string Address
		{
			get{return a;}
			set{a = value;}
		}
		public string Zip
		{
			get{return z;}
			set{z = value;}
		}

//		public override string ToString()
//		{
//			return Zip.ToString();
//		}

		#region Implementation of ITypedList

		public PropertyDescriptorCollection GetItemProperties(PropertyDescriptor[] listAccessors)
		{
			return this.pdc;
		}

		public string GetListName(PropertyDescriptor[] listAccessors)
		{
			return "Location";
		}
		#endregion
	}
	#endregion


	#region LocationPropertyDescriptor class

	class LocationPropertyDescriptor : PropertyDescriptor
	{
		PropertyDescriptor basePropDesc;
		private string id;
				
		public LocationPropertyDescriptor(PropertyDescriptor basePropDesc, string id)
			:base(basePropDesc)
		{
			this.basePropDesc = basePropDesc;
			this.id = id;
		}

		/// <override/>
		public override bool CanResetValue(object component)
		{
			return this.basePropDesc.CanResetValue(component);
		}

		/// <override/>
		public override object GetValue(object component)
		{
			try
			{
				Location loc = component as Location;
				if(loc == null)
					return null;
				object o = null;
				switch(id)
				{
					case "Address":
						o = loc.Address;
						break;
					case "Zip":
						o = loc.Zip;
						break;
					default:
						break;
				}
				return o;
			}
			catch
			{
				throw new ArgumentException("component must be Location type");
			}
			
			 
		}

		/// <override/>
		public override void ResetValue(object component)
		{
			SetValue(component, null);
		}

		/// <override/>
		public override void SetValue(object component, object value)
		{

			try
			{
				Location loc = component as Location;
				if(loc == null)
					return;
				switch(id)
				{
					case "Address":
						loc.Address = value as string;
						break;
					case "Zip":
						loc.Zip = value as string;
						break;
					default:
						break;
				}

			}
			catch
			{
				throw new ArgumentException("component must be MyObject type");
			}
		}

		/// <override/>
		public override bool ShouldSerializeValue(object component)
		{
			return this.basePropDesc.ShouldSerializeValue(component);
		}

		/// <override/>
		public override Type ComponentType 
		{ 
			get
			{
				return this.basePropDesc.ComponentType;
			}
		}
			
		/// <override/>
		public override bool IsReadOnly 
		{ 
			get
			{
				return false;
			}
		}
			
		/// <override/>
		public override Type PropertyType 
		{ 
			get
			{
				return this.basePropDesc.PropertyType;
			}
		}
	}
	#endregion
}
